# -*- coding: utf-8 -*-
# konfigurationsDialoge.py
import  wx

provider = wx.SimpleHelpProvider()
wx.HelpProvider.Set(provider)

### ----- Buttonzeile einfuegen ----------------------------
# Hilfsfunktion zum einfuegen der uerberall gleichen Buttonzeile
def Buttonzeile(dialog, sizer):
    # Trennlinie
    line = wx.StaticLine(dialog, -1, size=(20,-1), style=wx.LI_HORIZONTAL)
    sizer.Add(line, 0, wx.GROW|wx.RIGHT|wx.TOP, 5)

    btnsizer = wx.StdDialogButtonSizer()
    
    okbtn = wx.Button(dialog, wx.ID_OK)
    okbtn.SetHelpText("Beenden und uebernehmen")
    okbtn.SetDefault()
    btnsizer.AddButton(okbtn)
    dialog.Bind(wx.EVT_BUTTON, dialog.OnOKButton, okbtn)

    cancelBtn = wx.Button(dialog, wx.ID_CANCEL)
    cancelBtn.SetHelpText("Abbruch ohne die Werte zu uebernehmen")
    btnsizer.AddButton(cancelBtn)
    btnsizer.Realize()
    dialog.Bind(wx.EVT_BUTTON, dialog.OnCancelButton, cancelBtn)

    sizer.Add(btnsizer, 0, wx.ALL|wx.GROW|wx.RIGHT|wx.TOP, 5)

### ----- KlassenNamenAendern ----------------------------
class KlassenNamenAendern(wx.Dialog):
    def __init__(
            self, parent,ID,title,
            alterName,
            size=wx.DefaultSize, pos=wx.DefaultPosition, 
            style=wx.DEFAULT_DIALOG_STYLE):

        wx.Dialog.__init__(self, parent, ID, title, pos, size, style)

        sizer = wx.BoxSizer(wx.VERTICAL)

        label = wx.StaticText(self, -1, u"Namen der Klasse ändern")
        sizer.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)

        # Name der Klasse
        box = wx.BoxSizer(wx.HORIZONTAL)

        label = wx.StaticText(self, -1, "Name", size=(80,-1))
        label.SetHelpText(u"Ändern Sie den Namen")
        box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
        
        self.textName = wx.TextCtrl(self, -1, "", size=(80,-1))
        self.textName.SetHelpText("Klassenname")
        self.textName.ChangeValue(alterName)
        box.Add(self.textName, 1, wx.ALIGN_CENTRE|wx.ALL, 5)

        sizer.Add(box, 0, wx.GROW|wx.ALL, 5)
        
        Buttonzeile(self, sizer)
        self.SetSizer(sizer)
        sizer.Fit(self)

    def DatenSetzen(self, name):
        self.textName.ChangeValue(name)

    def OnOKButton(self, evt):
        self.EndModal(wx.ID_OK)

    def OnCancelButton(self, evt):
        self.EndModal(wx.ID_CANCEL)

### ----- KonfigurationAttribut ----------------------------
class KonfigurationAttribut(wx.Dialog):
    def __init__(
            self, parent,ID,title,
            name,typ,isAbstract,isClassVar,
            size=wx.DefaultSize, pos=wx.DefaultPosition, 
            style=wx.DEFAULT_DIALOG_STYLE):

        wx.Dialog.__init__(self, parent, ID, title, pos, size, style)

        sizer = wx.BoxSizer(wx.VERTICAL)

        label = wx.StaticText(self, -1, "Konfiguration des Attributs")
        sizer.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)

        # Name des Attributs
        box = wx.BoxSizer(wx.HORIZONTAL)

        label = wx.StaticText(self, -1, "Name", size=(80,-1))
        label.SetHelpText(u"Ändern Sie den Namen")
        box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
        
        self.textName = wx.TextCtrl(self, -1, "", size=(80,-1))
        self.textName.SetHelpText("Attributname")
        self.textName.ChangeValue(name)
        box.Add(self.textName, 1, wx.ALIGN_CENTRE|wx.ALL, 5)

        sizer.Add(box, 0, wx.GROW|wx.ALL, 5)

        # Typ des Attributs
        box = wx.BoxSizer(wx.HORIZONTAL)

        label = wx.StaticText(self, -1, "Typ",size=(80,-1))
        label.SetHelpText("Aendern Sie den Typ")
        box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)

        self.textTyp = wx.TextCtrl(self, -1, "", size=(80,-1))
        self.textTyp.SetHelpText("Typ des Attributs")
        self.textTyp.ChangeValue(typ)
        box.Add(self.textTyp, 1, wx.ALIGN_CENTRE|wx.ALL, 5)

        sizer.Add(box, 0, wx.GROW|wx.ALL, 5)
        
        # Abstrakt ?
        box = wx.BoxSizer(wx.HORIZONTAL)

        label = wx.StaticText(self, -1, "abstrakt ?")
        label.SetHelpText(u"auswählen, wenn")
        box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
        

        self.cbAbstrakt = wx.CheckBox(self, -1, "ist abstrakt", size=(280,-1))
        self.cbAbstrakt.SetHelpText(u"abstrakt wählen")
        box.Add(self.cbAbstrakt, 1, wx.ALIGN_CENTRE|wx.ALL, 5)
        self.cbAbstrakt.SetValue(isAbstract)

        sizer.Add(box, 0, wx.GROW|wx.ALL, 5)

        # Klassenvariable ?
        box = wx.BoxSizer(wx.HORIZONTAL)

        label = wx.StaticText(self, -1, "Klassenvariable ?")
        label.SetHelpText(u"auswählen, ob")
        box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
        

        self.cbClassVar = wx.CheckBox(self, -1, "ist Klassenvariable", size=(280,-1))
        self.cbClassVar.SetHelpText("ist Klassenvariable")
        box.Add(self.cbClassVar, 1, wx.ALIGN_CENTRE|wx.ALL, 5)
        self.cbClassVar.SetValue(isClassVar)

        sizer.Add(box, 0, wx.GROW|wx.ALL, 5)
        
        Buttonzeile(self, sizer)
        self.SetSizer(sizer)
        sizer.Fit(self)

    def DatenSetzen(self, name, typ, isClassVar):
        self.textName.ChangeValue(name)
        self.textTyp.ChangeValue(typ)
        self.cbAbstrakt.SetValue(istAbstract)
        self.cbClassVar.SetValue(isClassVar)

    def OnOKButton(self, evt):
        self.EndModal(wx.ID_OK)

    def OnCancelButton(self, evt):
        self.EndModal(wx.ID_CANCEL)

### ----- konfigurationMethode ----------------------------
### Kommentar zum Einfuegen neuer Parameter bei Py3
### Ich kann mir zwar vorstellen, was dahinter steckt,
### dass Py3 immer am Anfang der Liste neue Elemente einfuegt,
### habe aber keine Lust das hier zu heilen.
### Leider steckt die Verwaltung im Hintergrund und ist fuer
### mich nicht so leicht auszutricksen.
import sys
import  wx.lib.mixins.listctrl  as  listmix
class ParameterListCtrl(wx.ListCtrl,
                   listmix.ListCtrlAutoWidthMixin,
                   listmix.TextEditMixin
                   ):

    def __init__(self, parent, ID, pos=wx.DefaultPosition,
                 size=wx.DefaultSize, style=0, daten=[]):
        wx.ListCtrl.__init__(self, parent, ID, pos, size, style)
        self.daten=daten
        self.listctrldata=dict()
        self.SetzeDaten(daten)

        listmix.ListCtrlAutoWidthMixin.__init__(self)

        self.InsertColumn(0, "Parameter")
        self.InsertColumn(1, "   Typ   ")

        self.Erzeuge()

        self.SetColumnWidth(0, 100)
        self.SetColumnWidth(1, 100)
        self.currentItem = 0
        listmix.TextEditMixin.__init__(self)

    def Erzeuge(self):
        items = self.listctrldata.items()
        index=0 # nur initialisieren
        ## Fuer Py3 geht nicht sys.maxint
        for key, data in items:
            index = self.InsertItem(self.GetItemCount(), data[0])
            self.SetItem(index, 0, data[0])
            self.SetItem(index, 1, data[1])
            self.SetItemData(index, key)
            
    def SetStringItem(self, index, col, data):
        if col in range(2):
            wx.ListCtrl.SetItem(self, index, col, data)

    def SetzeDaten(self, daten):
        '''[("Parameter1","Typ1") ...]'''
        self.listctrldata = dict()
        for index in range(len(daten)):
            self.listctrldata.update({index:daten[index]})

    def VerlaengereDaten(self):
        self.DeleteAllItems()
        neu=('name','typ')
        self.daten.append(neu)
        self.listctrldata.update({len(self.listctrldata):neu})
        self.Erzeuge()

    def GibDaten(self):
        daten=[]
        for zeile in range(len(self.listctrldata)):
            daten.append(
                (self.GetItem(zeile,0).GetText(),
                 self.GetItem(zeile,1).GetText())
                )
        return daten


### -------------------------------------------------------------
class KonfigurationMethode(wx.Dialog):
    def __init__(
            self, parent,
            ID, title,
            name,typ,parameterliste,abstrakt,isClassMeth,
            size=wx.DefaultSize, pos=wx.DefaultPosition, 
            style=wx.DEFAULT_DIALOG_STYLE):
        
        wx.Dialog.__init__(self, parent, ID, title, pos, size, style)

        sizer = wx.BoxSizer(wx.VERTICAL)

        # Name
        box = wx.BoxSizer(wx.HORIZONTAL)

        label = wx.StaticText(self, -1, "Name")
        label.SetHelpText(u"Ändern Sie den Namen")
        box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)

        self.textName = wx.TextCtrl(self, -1, "", size=(80,-1))
        self.textName.SetHelpText("Methodenname")
        box.Add(self.textName, 1, wx.ALIGN_CENTRE|wx.ALL, 5)
        self.textName.ChangeValue(name)
        
        sizer.Add(box, 0, wx.GROW|wx.ALL, 5)

        #  Typ
        box = wx.BoxSizer(wx.HORIZONTAL)

        label = wx.StaticText(self, -1, "Typ")
        label.SetHelpText("Aendern Sie den Typ")
        box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)

        self.textTyp = wx.TextCtrl(self, -1, "", size=(80,-1))
        self.textTyp.SetHelpText("Typ der Methode")
        box.Add(self.textTyp, 1, wx.ALIGN_CENTRE|wx.ALL, 5)
        self.textTyp.ChangeValue(typ)

        sizer.Add(box, 0, wx.GROW|wx.ALL, 5)

        # Parameter
        box = wx.BoxSizer(wx.HORIZONTAL)

        label = wx.StaticText(self, -1, "Konfiguration der Parameter")
        box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
        
        sizer.Add(box, 0, wx.GROW|wx.ALL, 5)

        box = wx.BoxSizer(wx.HORIZONTAL)

        neuButton = wx.Button(self, -1,'neuer Parameter')
        neuButton.SetHelpText("neuer Parameter")
        box.Add(neuButton)
        self.Bind(wx.EVT_BUTTON, self.OnNeuerParameter, neuButton)
        
        label = wx.StaticText(self, -1, "ohne Parameter: Vorgabe lassen oder leer")
        box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)

        sizer.Add(box, 0, wx.GROW|wx.ALL, 5)

        # Parameterliste
        self.git=ParameterListCtrl(self, -1,
                                   style=wx.LC_REPORT
                                   | wx.BORDER_NONE
                                   | wx.LC_SORT_ASCENDING,
                                   daten=eval(parameterliste)
                                   )
        sizer.Add(self.git, 1, wx.EXPAND)
        
        # Abstrakt ?
        box = wx.BoxSizer(wx.HORIZONTAL)

        label = wx.StaticText(self, -1, "abstrakt ?")
        label.SetHelpText(u"auswählen, wenn")
        box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
        

        self.cbAbstrakt = wx.CheckBox(self, -1, "ist abstrakt", size=(280,-1))
        self.cbAbstrakt.SetHelpText("Abstrakt")
        box.Add(self.cbAbstrakt, 1, wx.ALIGN_CENTRE|wx.ALL, 5)
        self.cbAbstrakt.SetValue(abstrakt)

        sizer.Add(box, 0, wx.GROW|wx.ALL, 5)

        # Klassenmethode ?
        box = wx.BoxSizer(wx.HORIZONTAL)

        label = wx.StaticText(self, -1, "Klassenmethode ?")
        label.SetHelpText(u"auswählen, wenn")
        box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
        

        self.cbClMeth = wx.CheckBox(self, -1, "ist Klassenmethode", size=(280,-1))
        self.cbClMeth.SetHelpText("Klassenmethode")
        box.Add(self.cbClMeth, 1, wx.ALIGN_CENTRE|wx.ALL, 5)
        self.cbClMeth.SetValue(isClassMeth)

        sizer.Add(box, 0, wx.GROW|wx.ALL, 5)
        
        Buttonzeile(self, sizer)
        self.SetSizer(sizer)
        sizer.Fit(self)

    def OnNeuerParameter(self, evt):
        self.git.SetzeDaten(self.git.GibDaten())
        aktuelleDaten=self.git.VerlaengereDaten()

    def OnOKButton(self, evt):
        self.EndModal(wx.ID_OK)

    def OnCancelButton(self, evt):
        self.EndModal(wx.ID_CANCEL)

### ----- KonfigurationKlassenKarte ----------------------------
class KonfigurationKlassenKarte(wx.Dialog):
    def __init__(
            self, parent,
            ID, title, size=wx.DefaultSize, pos=wx.DefaultPosition, 
            style=wx.DEFAULT_DIALOG_STYLE):

        wx.Dialog.__init__(self, parent, ID, title, pos, size, style)

        sizer = wx.BoxSizer(wx.VERTICAL)

        label = wx.StaticText(self, -1, "Konfiguration der Objektdaten")
        sizer.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)

        # x-Koordinate
        box = wx.BoxSizer(wx.HORIZONTAL)

        label = wx.StaticText(self, -1, "x-Position")
        label.SetHelpText(u"Ändern Sie die x-Koordinate")
        box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
        # damit die Werte auszulesen sind, muessen sie Instanzvariable sein
        self.textX = wx.TextCtrl(self, -1, "", size=(80,-1))
        self.textX.SetHelpText("Wert der x-Koordinate")
        box.Add(self.textX, 1, wx.ALIGN_CENTRE|wx.ALL, 5)

        sizer.Add(box, 0, wx.GROW|wx.ALL, 5)

        # y-Koordinate
        box = wx.BoxSizer(wx.HORIZONTAL)

        label = wx.StaticText(self, -1, "y-Position")
        label.SetHelpText("Aendern Sie die y-Koordinate")
        box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)

        self.textY = wx.TextCtrl(self, -1, "", size=(80,-1))
        self.textY.SetHelpText("Wert der y-Koordinate")
        box.Add(self.textY, 1, wx.ALIGN_CENTRE|wx.ALL, 5)

        sizer.Add(box, 0, wx.GROW|wx.ALL, 5)
        
        # Breite
        box = wx.BoxSizer(wx.HORIZONTAL)

        label = wx.StaticText(self, -1, "Breite      ")
        label.SetHelpText("Aendern Sie die Breite")
        box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)

        self.textBreite = wx.TextCtrl(self, -1, "", size=(80,-1))
        self.textBreite.SetHelpText("Wert der Breite")
        box.Add(self.textBreite, 1, wx.ALIGN_CENTRE|wx.ALL, 5)

        sizer.Add(box, 0, wx.GROW|wx.ALL, 5)
        
        # Abstrakt ?
        box = wx.BoxSizer(wx.HORIZONTAL)

        label = wx.StaticText(self, -1, "abstrakt ?")
        label.SetHelpText(u"auswählen, ob")
        box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
        

        self.cbAbstrakt = wx.CheckBox(self, -1, "ist abstrakt", size=(280,-1))
        self.cbAbstrakt.SetHelpText("Abstrakt")
        box.Add(self.cbAbstrakt, 1, wx.ALIGN_CENTRE|wx.ALL, 5)

        sizer.Add(box, 0, wx.GROW|wx.ALL, 5)
        
        Buttonzeile(self, sizer)
        self.SetSizer(sizer)
        sizer.Fit(self)

    def DatenSetzen(self, x, y, breite, abstrakt):
        self.textX.ChangeValue(x)
        self.textY.ChangeValue(y)
        self.textBreite.ChangeValue(breite)
        self.cbAbstrakt.SetValue(abstrakt)

    def OnOKButton(self, evt):
        self.EndModal(wx.ID_OK)

    def OnCancelButton(self, evt):
        self.EndModal(wx.ID_CANCEL)

### ----- KonfigurationVerbinder ----------------------------
class KonfigurationVerbinder(wx.Dialog):
    def __init__(
            self, parent,
            ID, title,
            s,sk,st,z,zk,zt,name,typ,verbTyp,ri,
            size=wx.DefaultSize, pos=wx.DefaultPosition, 
            style=wx.DEFAULT_DIALOG_STYLE):

        wx.Dialog.__init__(self, parent, ID, title, pos, size, style)
        self.s,self.sk,self.st=s,sk,st
        self.z,self.zk,self.zt=z,zk,zt
        self.name,self.typ,self.verbTyp,self.ri=name,typ,verbTyp,ri

        sizer = wx.BoxSizer(wx.VERTICAL)

        label = wx.StaticText(self, -1, "Konfiguration des Verbinders\n von   "+
                              s+"    zu   "+z)
        sizer.Add(label, 0, wx.ALL, 5)
        
        # Kanten
        self.kanten=["N","O","S","W"]

        box = wx.BoxSizer(wx.HORIZONTAL)
        self.rb1 = wx.RadioBox(
                self, -1, "Startkante", wx.DefaultPosition, wx.DefaultSize,
                self.kanten, 4
                )        
        self.Bind(wx.EVT_RADIOBOX, self.EvtRadioBox1, self.rb1)
        box.Add(self.rb1, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
        self.rb1.SetSelection(self.kanten.index(self.sk))

        self.rb2 = wx.RadioBox(
                self, -1, "Zielkante", wx.DefaultPosition, wx.DefaultSize,
                self.kanten, 4
                )        
        self.Bind(wx.EVT_RADIOBOX, self.EvtRadioBox2, self.rb2)
        box.Add(self.rb2, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
        self.rb2.SetSelection(self.kanten.index(self.zk))
        sizer.Add(box, 0, wx.ALL, 5)        

        # Startteiler
        box = wx.BoxSizer(wx.HORIZONTAL)

        label = wx.StaticText(self, -1, "Teiler Startkante")
        label.SetHelpText(u"0 .. 100")
        box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
        
        self.textTeilerStart = wx.TextCtrl(self, -1, "", size=(20,-1))
        self.textTeilerStart.SetHelpText("0 .. 100")
        self.textTeilerStart.SetValue(self.st)
        self.Bind(wx.EVT_TEXT, self.EvtTextTeilerStart, self.textTeilerStart)
        box.Add(self.textTeilerStart, 1, wx.ALIGN_CENTRE|wx.ALL, 5)
        # Zielteiler
        
        label = wx.StaticText(self, -1, "Teiler Zielkante")
        label.SetHelpText(u"0 .. 100")
        box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
        
        self.textTeilerZiel = wx.TextCtrl(self, -1, "", size=(20,-1))
        self.textTeilerZiel.SetHelpText("Teiler Zielkante")
        self.textTeilerZiel.SetValue(self.zt)
        self.Bind(wx.EVT_TEXT, self.EvtTextTeilerZiel, self.textTeilerZiel)
        box.Add(self.textTeilerZiel, 1, wx.ALIGN_CENTRE|wx.ALL, 5)

        sizer.Add(box, 0, wx.GROW|wx.ALL, 5)
        
        # Typen
        self.typen=["Assoziation","Aggregation","Komposition","Vererbung"]
        box = wx.BoxSizer(wx.HORIZONTAL)
        self.rb3 = wx.RadioBox(
                self, -1, "Typen", wx.DefaultPosition, wx.DefaultSize,
                self.typen, 4
                )        
        self.Bind(wx.EVT_RADIOBOX, self.EvtRadioBox3, self.rb3)
        box.Add(self.rb3, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
        self.rb3.SetSelection(self.typ)
        sizer.Add(box, 0, wx.ALL, 5)        

        # Verbindertyp        
        self.verbinderTypen=["Gerade","einfacher Winkel","Doppelwinkel"]
        box = wx.BoxSizer(wx.HORIZONTAL)
        self.rb4 = wx.RadioBox(
                self, -1, "Verbindertypen", wx.DefaultPosition, wx.DefaultSize,
                self.verbinderTypen, 3
                )        
        self.Bind(wx.EVT_RADIOBOX, self.EvtRadioBox4, self.rb4)
        box.Add(self.rb4, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
        self.rb4.SetSelection(self.verbTyp)

        # Richtung (nicht bei Vererbung!)
        self.cb1 = wx.CheckBox(self, -1, "gerichtet")
        self.Bind(wx.EVT_CHECKBOX, self.EvtCheckBox, self.cb1)
        box.Add(self.cb1, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
        sizer.Add(box, 0, wx.ALL, 5)
        self.cb1.SetValue(False)
        if self.verbTyp!=2:
            if self.ri==1:
                self.cb1.SetValue(True)
        
        Buttonzeile(self, sizer)
        self.SetSizer(sizer)
        sizer.Fit(self)

    def EvtTextTeilerStart(self, event):
        self.st=self.textTeilerStart.GetValue()

    def EvtTextTeilerZiel(self, event):
        self.zt=self.textTeilerZiel.GetValue()

    def EvtRadioBox1(self, event):
        '''nicht dieselbe Kante'''
        i=event.GetInt()
        if i==self.rb2.GetSelection():
            self.rb1.SetSelection(self.kanten.index(self.sk))
        else:
            self.sk=self.kanten[i]

    def EvtRadioBox2(self, event):
        '''nicht dieselbe Kante'''
        i=event.GetInt()
        if i==self.rb1.GetSelection():
            self.rb2.SetSelection(self.kanten.index(self.zk))
        else:
            self.zk=self.kanten[i]

    def EvtRadioBox3(self, event):
        '''Typen'''
        i=event.GetInt()
        self.typ=i
        #keine Richtung bei Vererbung
        if i==3:
            self.ri=0
            ## ToDo Radiobutton setzen

    def EvtRadioBox4(self, event):
        '''Verbindertypen'''
        i=event.GetInt()
        #kein Doppelwinkel bei NO,SW usw
        if i==2:
            if (self.sk,self.zk) in [
                ('N','O'),('N','W'),('S','O'),('S','W'),
                ('O','N'),('W','N'),('O','S'),('W','S')
                ]:
               self.rb4.SetSelection(self.verbTyp)
        self.verbTyp=i

    def EvtCheckBox(self,event):
        '''Richtung nicht bei Vererbung'''
        if self.typ==3:
            self.cb1.SetValue(False)
            return
        if self.cb1.GetValue():
            #print(self.cb1.GetValue())
            self.ri=1
        else: self.ri=0

    def DatenSetzen(self, s, sk, st, z, zk, zt, name, typ, verbTyp, ri):
        self.s,self.sk,self.st=s,sk,st
        self.z,self.zk,self.zt=z,zk,zt
        self.name,self.typ,self.verbTyp,self.ri=name,typ,verbTyp,ri

    def OnOKButton(self, evt):
        self.EndModal(wx.ID_OK)

    def OnCancelButton(self, evt):
        self.EndModal(wx.ID_CANCEL)

class NamenListCtrl(wx.ListCtrl,
                   listmix.ListCtrlAutoWidthMixin,
                   listmix.TextEditMixin
                   ):

    def __init__(self, parent, ID, daten,
                 pos=wx.DefaultPosition,
                 size=wx.DefaultSize, style=0,):
        wx.ListCtrl.__init__(self, parent, ID, pos, size, style)
        self.daten=daten
        self.SetzeDaten(daten)

        listmix.ListCtrlAutoWidthMixin.__init__(self)

        self.InsertColumn(0, "Reihenfolge")
        self.InsertColumn(1, "Name des Attributs")

        self.Erzeuge()

        self.SetColumnWidth(0, 100)
        self.SetColumnWidth(1, 100)
        self.currentItem = 0
        listmix.TextEditMixin.__init__(self)

    def Erzeuge(self):
        items = self.listctrldata.items()
        index=0 # nur initialisieren
        ## Fuer Py3 geht nicht sys.maxint
        for key, data in items:
            index = self.InsertItem(self.GetItemCount(), data[0])
            self.SetItem(index, 0, str(index+1))
            self.SetItem(index, 1, data)
            self.SetItemData(index, key)
            
    def SetStringItem(self, index, col, data):
        if col in range(2):
            wx.ListCtrl.SetItem(self, index, col, data)

    def SetzeDaten(self, daten):
        '''<name>'''
        self.listctrldata = dict()
        for index in range(len(daten)):
            self.listctrldata.update({index:daten[index]})

### ----- KonfigurationReihenfolge -------------------------
class KonfigurationReihenfolge(wx.Dialog):
    def __init__(
            self, parent,
            ID, title,
            namenZumSortieren,
            size=wx.DefaultSize, pos=wx.DefaultPosition, 
            style=wx.DEFAULT_DIALOG_STYLE):
        
        wx.Dialog.__init__(self, parent, ID, title, pos, size, style)

        sizer = wx.BoxSizer(wx.VERTICAL)

        # Auswahl-Textfeld
        box = wx.BoxSizer(wx.HORIZONTAL)

        label = wx.StaticText(self, -1, "Reihenfolge durch Zeilennummer angeben\n"+
                              "1 2 3 4 5")
        label.SetHelpText(u"Ändern Sie den Namen")
        box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)

        self.textReihenfolge = wx.TextCtrl(self, -1, "1 2 3", size=(200,-1))
        self.textReihenfolge.SetHelpText("Reihenfolge durch Zeilennummer angeben")
        box.Add(self.textReihenfolge, 1, wx.ALIGN_CENTRE|wx.ALL, 5)
        
        sizer.Add(box, 0, wx.GROW|wx.ALL, 5)


        # Auswahlen
        box = wx.BoxSizer(wx.HORIZONTAL)

        self.git=NamenListCtrl(self, -1,
                                   namenZumSortieren,
                                   style=wx.LC_REPORT
                                   | wx.BORDER_NONE
                                   | wx.LC_SORT_ASCENDING
                                   )
        sizer.Add(self.git, 1, wx.EXPAND)
        
        Buttonzeile(self, sizer)
        self.SetSizer(sizer)
        sizer.Fit(self)

    def OnNeuerParameter(self, evt):
        aktuelleDaten=self.git.VerlaengereDaten()

    def OnOKButton(self, evt):
        self.EndModal(wx.ID_OK)

    def OnCancelButton(self, evt):
        self.EndModal(wx.ID_CANCEL)

